////////////////////////////////////////////////////////////////////////////
//
// ACd̎g.
//
//   Copyright by rubidesu 2017
//   http://www.gatelink.co.jp/hw/
//
//   Version 1.00 2017.04.26
//
//
// gp}CRɍ킹ĉL̂ǂꂩLɂ.
#define _PIC_12F629_
//#define _PIC_12F675_
//#define _PIC_12F683_
//
////////////////////////////////////////////////////////////////////////////

#ifdef _PIC_12F629_
#include <12f629.h>
#endif //_PIC_12F629_

#ifdef _PIC_12F675_
#include <12f675.h>
#endif //_PIC_12F675_

#ifdef _PIC_12F683_
#include <12f683.h>
#endif //_PIC_12F683_

#fuses INTRC_IO, NOWDT, PUT, NOPROTECT, NOMCLR, NOBROWNOUT

#use delay(clock=4000000)

#use fast_io(a)

#use rs232(BAUD=9600, XMIT=PIN_A1, INVERT)

#ifdef _PIC_12F683_
#rom 0x7FF = {0x3400}
#endif //_PIC_12F683_

typedef unsigned int1	BIT;
typedef unsigned int16	WORD;
typedef unsigned int32	DWORD;

#define HIGH 1
#define LOW  0

struct tagPORTA{
	short bit0;
	short bit1;
	short bit2;
	short bit3;
	short bit4;
	short bit5;
	short bit6;
	short bit7;
}PORTA;
#byte PORTA = 5

#define PULSE_OUT		PORTA.bit2
#define PULSE_IN		PORTA.bit3

BYTE bMaxPulse = 50;
BYTE bPulseCount = 0;

BYTE bNormalMode;

////////////////////////////////////////////////////////////////////////////
#INT_RA
void int_ra_isr(void)
{
	if(PULSE_IN == LOW){
		if(bNormalMode == TRUE){	//ʏv.
			switch(bPulseCount){
			case 0:
				PULSE_OUT = HIGH;
				break;
			case 25:
				PULSE_OUT = LOW;
				break;
			default:
				break;
			}

			bPulseCount = bPulseCount + 1;
			bPulseCount = bPulseCount % bMaxPulse;
		}
		else{
			bPulseCount = bPulseCount + 1;
		}
	}
}

////////////////////////////////////////////////////////////////////////////
// C.
//
// IN:
//
// OUT:
//
// RETURN:
//
////////////////////////////////////////////////////////////////////////////
main()
{
#ifdef _PIC_12F683_
	setup_oscillator(OSC_4MHZ);
#endif //_PIC_12F683_

	set_tris_a(0b00001000);

	setup_comparator(NC_NC_NC_NC);
#ifndef _PIC_12F629_
	setup_adc(adc_off);
	setup_adc_ports(NO_ANALOGS);
#endif //_PIC_12F629_

	PULSE_OUT = LOW;

	delay_ms(100);

	enable_interrupts(GLOBAL);

	bNormalMode = FALSE;	//gJE^[h.
	enable_interrupts(INT_RA3);
	delay_ms(1000);			//ACǧv.
	disable_interrupts(INT_RA3);

	if((bPulseCount >= 47) && (bPulseCount <= 53)){
		bMaxPulse = 50;	//50Hz.
	}
	else if((bPulseCount >= 57) && (bPulseCount <= 63)){
		bMaxPulse = 60;	//60Hz.
	}
	else{
		bMaxPulse = 99;	//Error.
	}
	printf("%2UHz(%Upulse)\r\n", bMaxPulse, bPulseCount);

	delay_ms(100);

	bPulseCount = 0;
	bNormalMode = TRUE;		//ʏ탂[h.
	enable_interrupts(INT_RA3);

	while(1){
		//forever.
	}
}

